找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 928|回复: 0

[分享] Create region from connected arcs and lines

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-7 00:58:06 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
        //Create region from connected arcs and lines
        [CommandMethod("craw")]
        public static void CreateRegionFromConnected()
        {
            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;

            Editor ed = doc.Editor;

            Database db = doc.Database;

            DBObjectCollection objs = new DBObjectCollection();

            DBObjectCollection regcoll = new DBObjectCollection();

            using (Transaction tr = db.TransactionManager.StartTransaction())
            {

                BlockTableRecord btr = tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite) as BlockTableRecord;

                TypedValue[] tvs = new TypedValue[] { new TypedValue(0, "line,arc") };

                Point3dCollection points = new Point3dCollection();

                SelectionFilter sf = new SelectionFilter(tvs);

                PromptSelectionResult sres = ed.GetSelection(sf);

                if (sres.Status != PromptStatus.OK)
                {
                    ed.WriteMessage("\nInvalid selection!");

                    return;
                }

                foreach (SelectedObject selobj in sres.Value)
                {
                    DBObject obj = tr.GetObject(selobj.ObjectId, OpenMode.ForWrite, false) as DBObject;

                    objs.Add(obj);

                }

                regcoll = Region.CreateFromCurves(objs);

                Region reg = regcoll[0] as Region;

                btr.AppendEntity(reg);

                tr.AddNewlyCreatedDBObject(reg, true);
                // you might be want to remove the parent objects here,
                // because of DELOBJ variable did not effect :
                //foreach (DBObject obj in objs)
                //    obj.Erase();  // uncomment this code block if needs

                tr.Commit();
            }
        }
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-17 22:36 , Processed in 0.171572 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表